<!DOCTYPE html>
<html>

<head>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body>
  <div class="container">
    <h2>Registration Car Form</h2>

    <div class="jumbotron container">
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="input-fname">First Name</label>
        </div>
        <div class="col-sm-9">
          <input type="text" id="input-fname" name="firstname" placeholder="Your first name ..." class="form-control">
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="input-lname">Last Name</label>
        </div>
        <div class="col-sm-9">
          <input type="text" id="input-lname" name="lastname" placeholder="Your last name ..." class="form-control">
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="country-select">Country</label>
        </div>
        <div class="col-sm-3">
          <select id="country-select" name="country" class="form-control">
          </select>
        </div>
        <div class="col-sm-3">
          <label for="region-type-select">Region</label>
        </div>
        <div class="col-sm-3">
          <select id="region-type-select" name="region" class="form-control" >
          </select>
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="car-select">Car</label>
        </div>
        <div class="col-sm-3">
          <select id="car-select" name="car" class="form-control">
          </select>
        </div>
        <div class="col-sm-3">
          <label for="car-type-select">Car type</label>
        </div>
        <div class="col-sm-3">
          <select id="car-type-select" name="car-type" disabled class="form-control">
          </select>
        </div>
      </div>
      <div class="row">
        <div class="col-sm-12" style="text-align: right;">
          <button class="btn btn-info" id="btn-send"> Send </button>
        </div>
      </div>
    </div>
  </div>
</body>

<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  // car brand information
  var gJsonCarData = `[
                          {"brandId": "0","brandName": "None", "brandTypes": []}, 
                          {"brandId": "1","brandName": "Audi", "brandTypes": [{"typeId":"0", "typeName":"Q3"},{"typeId":"1","typeName":"Q5"},{"typeId":"2","typeName":"A4"}]},
                          {"brandId": "2","brandName": "BMW", "brandTypes": [{"typeId":"0","typeName":"1 series"},{"typeId":"1","typeName":"X series"},{"typeId":"2","typeName":"Z series"}]},
                          {"brandId": "3","brandName": "Citroen", "brandTypes": [{"typeId":"0","typeName":"new C3"},{"typeId":"1","typeName":"C4"},{"typeId":"2","typeName":"BERLINGO"}]}
                        ]`;

  // country information
  var gJsonCountryData = `[
                            {"countryId": "0","countryName": "None", "regionTypes": []}, 
                            {"countryId": "1","countryName": "Việt nam", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0", "regionName":"Hà Nội"},
                                                                          {"regionId":"1","regionName":"Hồ Chí Minh"},
                                                                          {"regionId":"2","regionName":"Đà Nẵng"}]},
                            {"countryId": "2","countryName": "Mỹ", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0","regionName":"Atlanta"},
                                                                          {"regionId":"1","regionName":"New York"},
                                                                          {"regionId":"2","regionName":"Boston"}
                                                                        ]},
                            {"countryId": "3","countryName": "Phần lan", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0","regionName":"Nam Phần Lan"},
                                                                          {"regionId":"1","regionName":"Tây Phần Lan"},
                                                                          {"regionId":"2","regionName":"Đông Phần Lan"}
                                                                        ]}
                          ]`;

  var gObjectCarData = JSON.parse(gJsonCarData);
  var gObjectCountryData = JSON.parse(gJsonCountryData);

  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  $(document).ready(function () {
    onPageLoaing();
  })
  $("#car-select").on("change", function () {
    onCarSelectChange(this);
  })
  $("#country-select").on("change",function(){
    onCountrySelectChange(this)
  });
  $("#btn-send").on("click", onBtnSendClick);
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  function onPageLoaing() {
    loadDataToSelectCar();
    loadDataToCountry();
  }
  function onCarSelectChange(paramCarSelect) {
    var vBrandId = $(paramCarSelect).val();
    //console.log(vBrandId);
    loadDataToCarType(vBrandId);
  }
  function onCountrySelectChange(paramCountrySelect) {
    var vCountryId = $(paramCountrySelect).val();
    //console.log(vCountryId);
    loadDataToRegion(vCountryId);
  }
  function onBtnSendClick() {
    var vObjCar = {
      /*firstName:"",
      lastName:"",
      country:"",
      region:"",*/
      countryId:"",
      countryName:"",
      regionId:"",
      regionName:"",
      brandId: -1,
      brandName: "",
      typeId: -1,
      typeName: ""
    }
    getDataForm(vObjCar);
    var vValid = checkDataObj(vObjCar);
    if (vValid) {
      showDataObj(vObjCar);
    }
  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  function loadDataToSelectCar() {
    var vSelectCar = $("#car-select");
    for (var bI = 0; bI < gObjectCarData.length; bI++) {
      $("<option/>", {
        "value": gObjectCarData[bI].brandId,
        "text": gObjectCarData[bI].brandName,
      }).appendTo(vSelectCar);
    }
  }
  function loadDataToCountry() {
    var vSelectCountry = $("#country-select");
    for (var bI = 0; bI < gObjectCountryData.length; bI++) {
      $("<option/>", {
        "value": gObjectCountryData[bI].countryId,
        "text": gObjectCountryData[bI].countryName,
      }).appendTo(vSelectCountry);
    }
  }
  /**
   * get brandType by brandId
   * input: brandId of a car
   * output: brandType name of found car. If not found, it returns null
   */
  function getBrandTypeByBrandID(paramBrandId) {
    var vBrandFound = false;
    var vBrandTypesResult = null;
    var vIterator = 0;
    while (!vBrandFound && vIterator < gObjectCarData.length) {
      if (gObjectCarData[vIterator].brandId === paramBrandId) {
        vBrandFound = true;
        vBrandTypesResult = gObjectCarData[vIterator].brandTypes;
      }
      else {
        vIterator++;
      }
    }
    return vBrandTypesResult;
  }
  function getRegionByCountryId(paramCountryId) {
    var vCountryFound = false;
    var vRegionResult = null;
    var vIterator = 0;
    while (!vCountryFound && vIterator < gObjectCountryData.length) {
      if (gObjectCountryData[vIterator].countryId === paramCountryId) {
        vCountryFound = true;
        vRegionResult = gObjectCountryData[vIterator].regionTypes;
      }
      else {
        vIterator++;
      }
    }
    return vRegionResult;
  }
  function loadDataToRegion(paramCountryId) {
    var vRegionType = getRegionByCountryId(paramCountryId);
    var vRegionTypeSelect = $("#region-type-select");
    $("#region-type-select").html("");
    for (var bI = 0; bI < vRegionType.length; bI++) {
      $("<option/>", {
        "value": vRegionType[bI].regionId,
        "text": vRegionType[bI].regionName,
      }).appendTo(vRegionTypeSelect);
    }
  }
  function loadDataToCarType(paramBrandId) {
    var vBrandTypes = getBrandTypeByBrandID(paramBrandId);
    var vCarTypesSelect = $("#car-type-select");
    $("#car-type-select").html("");
    if (vBrandTypes.length == 0) {
      vCarTypesSelect.prop("disabled", "disabled");
    } else {
      vCarTypesSelect.prop("disabled", false);
    }
    for (var bI = 0; bI < vBrandTypes.length; bI++) {
      $("<option/>", {
        "value": vBrandTypes[bI].typeId,
        "text": vBrandTypes[bI].typeName,
      }).appendTo(vCarTypesSelect);
    }
  }
  function getDataForm(paramObjCar) {
    /*var vFirstName = $("#input-fname");
    var vLastName = $("#input-lname");
    var vCountry = $("#country-select");
    var vRegion = $("#region-type-select");
    var vCar = $("#car-select");
    var vCarType = $("#car-type-select");
    paramObjCar.firstName = $("#input-fname").val();
    paramObjCar.lastName = $("#input-lname").val();*/
    paramObjCar.countryId = $("#country-select").val();
    paramObjCar.countryName = $("#country-select option:selected").text();
    paramObjCar.regionId = $("#region-type-select").val();
    paramObjCar.regionName = $("#region-type-select option:selected").text();
    paramObjCar.brandId = $("#car-select").val();
    paramObjCar.brandName = $("#car-select option:selected").text();
    paramObjCar.typeId = $("#car-type-select").val();
    paramObjCar.typeName = $("#car-type-select option:selected").text();
  }
  function checkDataObj(paramObjCar) {
    if (paramObjCar.brandId == 0) {
      alert("Choose car!");
      $("#car-select").focus();
      return false;
    }
    if (paramObjCar.typeId == -1) {
      alert("Choose car type!");
      $("#car-type-select").focus();
      return false;
    }
    if (paramObjCar.countryId == 0){
      alert("Choose your country!");
      $("#country-select").focus();
      return false;
    }
    if (paramObjCar.regionId == -1) {
      alert("Choose your region!");
      $("#region-type-select").focus();
      return false;
    }
    return true;
  }
  function showDataObj(paramObjCar) {
    console.log("Brand Id: " + paramObjCar.brandId);
    console.log("Brand Name: " + paramObjCar.brandName);
    console.log("Type Id: " + paramObjCar.typeId);
    console.log("Type Name: " + paramObjCar.typeName);
    console.log("Country Id: " + paramObjCar.countryId);
    console.log("Country Name: " + paramObjCar.countryName);
    console.log("Region Id: " + paramObjCar.regionId);
    console.log("Region Name: " + paramObjCar.regionName);
  }
</script>

</html>